/*
 Copyright© 2010, 2011 Ahmad Balaa, Oday Maleh

 This file is part of Cura.

	Cura is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cura is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cura.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cura.security;

/*
 * Description: This class just starts the SMS broadcast receiver upon starting the phone.
 */

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

public class BootReceiver extends BroadcastReceiver {

	@Override
	public void onReceive(Context context, Intent intent) {
		Log.d("Boot", "Service Started");
		SharedPreferences prefs = PreferenceManager
				.getDefaultSharedPreferences(context);
		// fetch the shared preferences
		Intent i = new Intent();
		// start the intent
		i.setAction("com.cura.security.SMSService");
		// set the action to be SMSService page
		if (prefs.getBoolean("enableSMS", false))
			// if the SMS broadcast receiver is not enabled, enable it
			context.startService(i);
		else
			Log.d("Boot", "Service not Started");
	}
}
